#include <stdio.h>
#include <pvm3.h>

/* Hana Butkova, A06076 */
/* PVM - model Farmer - Workers                               */
/* Pouzivane kody zprav:                                      */
/*   4 ... broadcast (id sefa  -> delnici)                    */  
/*   5 ... odpoved   (id delnika -> sef)                      */ 
/*   6 ... zadani ukolu (sef -> delnik),                      */
/*         zaporna hodnota cisla - konec jednoho nasobeni     */
/*   7 ... vysledek     (delnik -> sef),                      */
/*  8 ... nova data                                           */
/*        zaporne prvni cislo - konec cinnosti                 */

void printMatrixWithGrade(int * matrix);
void printMatrix(int * matrix, int grade);
int* readMatrix(char file[]);
  
main(int argc, char *argv[]) {
  int mytid;      /*  identifikator procesu sef  */
  int tids[32];   /*  identifikatory procesu delnici */
  int nproc;      /*  pocet delniku */
  int m;          /*  kolik souradnic ma matice */
  int workSize;   /* velikost pridelovane prace */
  int power;      /* mocnina */
  int* rslt;      /*  ukazatel na pole vysledku */ 
  int last_rslt; 
  int worker_cnt = -1894;   /* nastaveni pro kontrolu smysluplnosti */
  int rslt_num = 0;   /*  kolik prvocisel uz se naslo */
  int cnt_sent = 0;    /*  kolik prikazu odeslano */
  int cnt_received = 0;/*  kolik vysledku prijato */
  int i, tid, work;  /*  pomocne promenne */
  int k = 0;      /* cislo souradnice, ktera jeste neni prirazena */
  int end_param = 0;
  int vytvoreno = 0;  /*  pocet uspesne vytvorenych delniku */
  int* tidc;      /* pomocny ukazatel pro vytvareni delniku */  
  
  int grade;      /* stupen matice */
	int * matrix;    /* vstupni matice */
	int tmp;
	int j = 0;
	
	
	printf("\n-----------------------------\n");
	printf(" Vypocet n-te mocniny matice\n");
	printf("-----------------------------\n");	
	
	/* kontrola zadani spravneho poctu argumentu */
	if ((argc != 5) && (argc != 2)){
    printf("Nespravny pocet parametru.\n");
    printf("Spusteni: \n\tfarmer <nazev souboru matice> <mocnina> <pocet delniku> <jednotka prace - pocet souradnic>");
    printf("\n\t  nebo\n");
    printf("\tfarmer <nazev souboru matice> - ukazkove hodnoty\n\n");
    return 1;
  }
  
  char * file = argv[1];
  
  /* spusteni s prednastavenymi hodnotami */
  if (argc == 2){
    power = 2;
	  nproc = 4;
	  workSize = 2;
    printf("Nastaveni hodnot:\n");
    printf("mocnina: %d ; pocet delniku: %d ; jednotka prace: %d\n\n", power, nproc, workSize);   
  }
  
  /* kontrola spravnosti zadanych cisel */
  else {
    power = atoi(argv[2]);
	  nproc = atoi(argv[3]);
	  workSize = atoi(argv[4]);
	
	  if (power < 2){
      printf("Prilis mala mocnina (%d).\n", power);
      printf("Zadejte cislo >= 2.\n\n");
      return 1;
    }  
    if (nproc < 1){
      printf("Nespravny pocet delniku (%d).\n", nproc);
      printf("Zadejte cislo >= 1.\n\n");
      return 1;
    }	
    if (workSize < 1){
      printf("Nespravne zadana jednotka prace (%d).\n", workSize);
      printf("Zadejte cislo >= 1.\n\n");
      return 1;
    }
  }

	matrix = readMatrix(file);   /* nacteni matice ze textoveho souboru */
	if (matrix == NULL) {
		printf("Konec programu\n\n");
		return 1;
	}
	
	grade = *matrix; /* prvni hodnota matice je jeji stupen */

	printMatrixWithGrade(matrix);    

  m = grade * grade;
  
  printf("Mocnina : %d\n", power);
  printf("Pocet delniku : %d\n", nproc);
  printf("Kus prace : %d\n", workSize);

  /* inicializace pole pro vysledky vypoctu */
  rslt = (int *) malloc ((m + 1) * sizeof(int));  
  
  mytid = pvm_mytid();  /* prihlaseni do PVM  */

  /* vytvoreni delniku */
  tidc = tids;
  while (nproc > vytvoreno) {
   if (pvm_spawn("worker", (char**)0, 0, "", 1, tidc)) {
      printf("Vytvoren delnik %d.\n", *tidc);
      vytvoreno++;
      tidc++;
   } else {
      printf("Chyba pri vytvareni delnika. Cislo chyby %d\n", *tidc);
   }
  }

  /* uvodni komunikace sefa s delniky (registrace prac. sil) */
  pvm_initsend(PvmDataDefault);   // inicializace bufferu 
  pvm_pkint(&mytid, 1, 1);    // ulozeni identifikace  
  pvm_mcast(tids, nproc, 4);  // broadcast zpravy s kodem 4 vsem delnikum 
  
  // cekani na odezvu od delniku 
  for(i = 0; i < nproc; i++) { 
    pvm_recv(-1, 5);         // 5 je kod zpravy 
    pvm_upkint(&tid, 1, 1);  // cislo delnika   
    pvm_upkint(&worker_cnt, 1, 1);  // pocet zpracovanych kousku prace delnika 
    printf("Delnik cislo %d k praci pripraven!\n", tid);
  }
  
  /* -------------------------- vypocet ---------------------------------- */
  
  int cykl;
  for (cykl = 0; cykl < power - 1; cykl++){
    
    // zaslani matic
    pvm_initsend(PvmDataDefault);   // inicializace bufferu 
    pvm_pkint(matrix, grade * grade + 1, 1);    // ulozeni prvni matice
    /* ulozeni druhe matice */
    if (cykl == 0){
      pvm_pkint(matrix, grade * grade + 1, 1);
    }
    else {
      pvm_pkint(rslt, grade * grade + 1, 1);
    }  
    pvm_mcast(tids, nproc, 8);  // broadcast zpravy s kodem 8 vsem delnikum 
  
    *rslt = grade;
    rslt_num = 0;
  
    k = 0;  
  
  
    // zaslani prace vsem delnikum  
    i = 0;  
    while ((i < nproc) && (k < m)) {
      pvm_initsend(PvmDataDefault);   // inicializace bufferu 
      /* velikost prace - zadana nebo to, co zbyva */
      work = (k + workSize > m) ? (m - k) : workSize;
      pvm_pkint(&work, 1, 1);
      for (j = 0; (j < work); j++){
        pvm_pkint(&k, 1, 1);            // ulozeni souradnice k pocitani
        k++;
      }
      pvm_send(tids[i], 6);           // zaslani zpravy s kodem 6 (zaslani prace)
      cnt_sent++;  
      i++;
    }

    // kdo dokoncil, dostane dalsi ukol 
    while (k < m) {               // pokud jsou neprirazene souradnice
      pvm_recv (-1, 7);           // cekani na vysledek 
      cnt_received++;
      pvm_upkint (&tid, 1, 1);
      pvm_upkint (&tmp, 1, 1);    // prijmuti poctu vypocitanych souradnic
      for (i = 0; i < tmp; i++){
        pvm_upkint (&j, 1, 1);    // prijmuti cisla souradnice
        pvm_upkint (rslt + j + 1, 1, 1);    // kopirovani hodnoty prvku do pole vysledku na spravnou pozici
        rslt_num++;
      }   
    
      pvm_upkint(&worker_cnt, 1, 1);  // pocet zpracovanych kousku prace delnika 
    
      // zadani dalsiho ukolu 
      pvm_initsend(PvmDataDefault);   // inicializace bufferu 
    
      work = (k + workSize > m) ? (m - k) : workSize; // velikost prace
      pvm_pkint(&work, 1, 1);
      for (j = 0; (j < work); j++){
        pvm_pkint(&k, 1, 1);            // zadani souradnice k praci
        k++;
      }
      cnt_sent++;
      pvm_send(tid, 6);               // zaslani zpravy s kodem 6 
    }

    // dobeh rozdelanych ukolu 
    while (cnt_sent > cnt_received) { 
      pvm_recv (-1, 7);           // cekani na vysledek 
      cnt_received++;
      pvm_upkint (&tid, 1, 1);
      pvm_upkint (&tmp, 1, 1);    // pocet vypocitanych souradnic 
    
      for (i = 0; i < tmp; i++){
        pvm_upkint (&j, 1, 1);    // pozice prvku    
        pvm_upkint (rslt + j + 1, 1, 1);    // kopirovani hodnoty prvku do pole vysledku     
        rslt_num++;
      }      
      pvm_upkint (&worker_cnt, 1, 1); 
    }
  
    // oznameni ukonceni jednoho nasobeni
    for(i = 0; i < nproc; i++) { 
      k = -m;
      pvm_initsend(PvmDataDefault);   // inicializace bufferu 
      pvm_pkint(&k, 1, 1);            // ulozeni hodnoty k 
      pvm_send (tids[i], 6);          // zaslani zpravy s kodem 6 
    }

  }
  /* -------------------------- konec vypoctu ---------------------------- */

  // uvolneni delniku
  for(i = 0; i < nproc; i++) { 
    k = -m;
    pvm_initsend(PvmDataDefault);   // inicializace bufferu 
    pvm_pkint(&k, 1, 1);            // ulozeni hodnoty k 
    pvm_send (tids[i], 8);          // zaslani zpravy s kodem 6 
    
    
    pvm_recv (tids[i], 7);          // cekani na ukonceni 
    pvm_upkint (&tid, 1, 1);
    pvm_upkint (&last_rslt, 1, 1); 
    pvm_upkint (&worker_cnt, 1, 1);        
    printf("Delnik %d konci s hodnotou %d ! Vykonal prace: %d \n",
      tids[i], last_rslt, worker_cnt);   
  }
  
  printf("\nVysledek - %d. mocnina:\n", power);
  // tisk vysledku 
  printMatrixWithGrade(rslt);

  // ukonceni cinnosti v PVM 
  pvm_exit();

}


// vypis matice
void printMatrixWithGrade(int * matrix){
	int i, j;
	int grade = *matrix;
	
	printf("Matice %d x %d\n", grade, grade);
	
	for (i = 1; i < grade * grade + 1; i++){
    printf("%d\t", *(matrix + i));
    if (i % grade == 0){
      printf("\n");
    }
  }
	printf("\n");
}

// vypis matice
void printMatrix(int * matrix, int grade){
	int i, j;
	
	printf("Matice %d x %d\n", grade, grade);
	
	for (i = 0; i < grade * grade; i++){
    printf("%d\t", *(matrix + i));
    if ((i + 1) % grade == 0){
      printf("\n");
    }
  }
	printf("\n");
}

// nacteni matice z textoveho souboru
int* readMatrix(char file[]){
	FILE *fr;
	
	fr = fopen(file, "r");

	if (!fr){
		printf("Soubor \"%s\" se nepodarilo otevrit.\n", file);
		return NULL;
	}

	int grade, tmp;
	fscanf(fr, "%d", &grade);

	int * pMatrix = (int *) malloc((grade * grade + 1) * sizeof(int));
	*pMatrix = grade;

  int i;
	for (i = 0; i < grade * grade; i++){
		fscanf(fr, "%d", &tmp);		
		*(pMatrix + i + 1) = tmp;
	}

	fclose(fr);

	return pMatrix;
}
